<?php
// 
// WHLX CMS - init.php
// 
// 20040330 - 0.00 alpha
// 20040402 - 0.02 alpha    名称変更:whlx_init.php -> init.php etc. 
// 20040402 - 0.03 alpha    アイテム挿入位置を示す mark は不要と考え, コメント・アウト. 
// 20040410 - 0.04 alpha    外部ファイルの整理. ディレクトリ類は 'path.ini', へ移動. 設定類は 'whlx.ini' へ移動. 
// 20040410 - 0.05 alpha    XML/XSLT 形式の出力に変更. それに伴い, '_script.xsl' を作成し, XSLTファイルとして之を指定する. 
// 




error_reporting( E_ERROR | E_PARSE );


$error   =  1;
$message =  'FAILED    : 初期化に失敗しました. ';
$others  =  '';


// './path.ini' を読み込み, 設定ファイルやライブラリ・ファイルの相対パスを取得します. 
// './path.ini' はスクリプトと同じディレクトリに置く必要があります. 
$whlx =  parse_ini_file( './path.ini',      true );    
$whlx =  array_merge( $whlx, parse_ini_file( $whlx[ 'directory' ][ 'hidden' ].  './whlx.ini', true ) );    

include_once  $whlx[ 'directory' ][ 'library' ].  './utilities.php';
include_once  $whlx[ 'directory' ][ 'library' ].  './formdata.php';
include_once  $whlx[ 'directory' ][ 'library' ].  './domxml.php';

define( 'WHLX_XML_FILEMODE', 0744  );    // 
define( 'WHLX_XML_VERSION' , '1.0' );    // 


$result =  WHLX_Initializer( $error, $message, $others, $whlx );

$others =  
	'		<title> WHLX CMS - 初期化スクリプト </title> '.  "\n".    
	'		<form password="yes"> '.                         "\n".    
	'			<action >./init.php</action > '.         "\n".    
	'		</form> '.                                       "\n";    

if( $result ) $output =  WHLX_PostingResponse( $error, $message, $others, './_script.xsl' );
else          $output =  WHLX_PostingResponse( $error, $message, $others, './_script.xsl' );


WHLX_ResponseHeader_XML ();
echo  $output;


exit;








function  WHLX_Initializer( &$error, &$message, &$others, $data )
{
	// class WHLX_Formdata は './utilities.php' の中で記述されている補助クラスです. 
	// Formdata::form()   でスクリプトに送信された フォーム・データ を取得できます. 返値は配列になります. 
	// Formdata::header() でスクリプトに送信された HTTPリクエスト   を取得できます. 返値は配列になります. 
	$formclass =  new WHLX_Formdata();     
	$form      =  $formclass->form  ();    
	$header    =  $formclass->header();    

	// function WHLX_PasswordChecker は './utilities.php' の中で記述されている補助関数です. 
	if( !WHLX_PasswordChecker( $form[ 'password' ], $data[ 'owner' ][ 'password' ] ) ) return false;

	WHLX_Initializer_ListCategories  ( $data );
	WHLX_Initializer_ListArticles    ( $data );
	WHLX_Initializer_ListComments    ( $data );
	WHLX_Initializer_ListTrackbacks  ( $data );
	WHLX_Initializer_InitialCategory ( $data );
	WHLX_Initializer_InitialArticle  ( $data );
	WHLX_Initializer_ListInformations( $data );
	WHLX_Initializer_ListOthers      ( $data );

	$error   =  0;
	$message =  'SUCCEEDED : 初期化に成功しました. ';
	$others  =  '';

	return true;
}




function  WHLX_Initializer_ListCategories  ( $ini )
{
	$dom_root            =  WHLX_DomXML_NewDocument  ( WHLX_XML_VERSION );    
	$txt_pi_xslt         =  WHLX_DomXML_RegisterXSLT ( $dom_root, $ini[ 'xslt' ][ 'categories'   ], WHLX_XML_VERSION, 'text/xsl', 'UTF-8' );
	$dom_whlx            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_root      , 'whlx'      , '' );    
	$dom_categories      =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_whlx      , 'categories', '' );    
//	$dom_mark            =  WHLX_DomXML_CreateComment( $dom_root, $dom_categories, ' mark '         );    
	$dom_item            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_categories, 'item'      , '' );    

	$title_categories =  'Categories';    

	$dom_whlx ->set_attribute( 'series'  , '0001'                                );    
//	$dom_whlx ->set_attribute( 'category', '0001'                                );    
	$dom_whlx ->set_attribute( 'title'   , $title_categories                     );    
	$dom_item ->set_attribute( 'id'      , '0001'                                );    
	$dom_item ->set_attribute( 'resource', $ini[ 'initial_category' ][ 'url'   ] );    
	$dom_item ->set_attribute( 'title'   , $ini[ 'initial_category' ][ 'title' ] );    

	return WHLX_DomXML_Output( $dom_root, $ini[ 'directory' ][ 'data' ].  $ini[ 'filename' ][ 'categories'   ], WHLX_XML_FILEMODE );    
}




function  WHLX_Initializer_ListArticles    ( $ini )
{
	$dom_root            =  WHLX_DomXML_NewDocument  ( WHLX_XML_VERSION );    
	$txt_pi_xslt         =  WHLX_DomXML_RegisterXSLT ( $dom_root, $ini[ 'xslt' ][ 'articles'     ], WHLX_XML_VERSION, 'text/xsl', 'UTF-8' );
	$dom_whlx            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_root      , 'whlx'      , '' );    
	$dom_articles        =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_whlx      , 'articles  ', '' );    
//	$dom_mark            =  WHLX_DomXML_CreateComment( $dom_root, $dom_articles  , ' mark '         );    
	$dom_item            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_articles  , 'item'      , '' );    

	$title_articles   =  'Articles';    

	$dom_whlx ->set_attribute( 'series'  , '0001'                                );    
//	$dom_whlx ->set_attribute( 'category', '0001'                                );    
	$dom_whlx ->set_attribute( 'title'   , $ini[ 'title' ][ 'articles'   ]       );    
	$dom_item ->set_attribute( 'id'      , '0001'                                );    
	$dom_item ->set_attribute( 'resource', $ini[ 'initial_article'  ][ 'url'   ] );    
	$dom_item ->set_attribute( 'title'   , $ini[ 'initial_article'  ][ 'title' ] );    

	return WHLX_DomXML_Output( $dom_root, $ini[ 'directory' ][ 'data' ].  $ini[ 'filename' ][ 'articles'     ], WHLX_XML_FILEMODE );    
}




function  WHLX_Initializer_ListComments    ( $ini )
{
	$dom_root            =  WHLX_DomXML_NewDocument  ( WHLX_XML_VERSION );    
	$txt_pi_xslt         =  WHLX_DomXML_RegisterXSLT ( $dom_root, $ini[ 'xslt' ][ 'comments'     ], WHLX_XML_VERSION, 'text/xsl', 'UTF-8' );
	$dom_whlx            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_root      , 'whlx'         , '' );    
	$dom_comments        =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_whlx      , 'comments  '   , '' );    
//	$dom_mark            =  WHLX_DomXML_CreateComment( $dom_root, $dom_comments  , ' mark '            );    

	$title_comments   =  'Comments';    

	$dom_whlx ->set_attribute( 'series'  , '0001'                                );    
//	$dom_whlx ->set_attribute( 'category', '0001'                                );    
	$dom_whlx ->set_attribute( 'title'   , $ini[ 'title' ][ 'comments'   ]       );    

	return WHLX_DomXML_Output( $dom_root, $ini[ 'directory' ][ 'data' ].  $ini[ 'filename' ][ 'comments'     ], WHLX_XML_FILEMODE );     
}




function  WHLX_Initializer_ListTrackbacks  ( $ini )
{
	$dom_root            =  WHLX_DomXML_NewDocument  ( WHLX_XML_VERSION );    
	$txt_pi_xslt         =  WHLX_DomXML_RegisterXSLT ( $dom_root, $ini[ 'xslt' ][ 'trackbacks'   ], WHLX_XML_VERSION, 'text/xsl', 'UTF-8' );
	$dom_whlx            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_root      , 'whlx'         , '' );    
	$dom_trackbacks      =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_whlx      , 'trackbacks'   , '' );    
//	$dom_mark            =  WHLX_DomXML_CreateComment( $dom_root, $dom_trackbacks, ' mark '            );    

	$dom_whlx ->set_attribute( 'series'  , '0001'            );    
//	$dom_whlx ->set_attribute( 'category', '0001'            );    
	$dom_whlx ->set_attribute( 'title'   , $ini[ 'title' ][ 'trackbacks' ]       );    

	return WHLX_DomXML_Output( $dom_root, $ini[ 'directory' ][ 'data' ].  $ini[ 'filename' ][ 'trackbacks'   ], WHLX_XML_FILEMODE );     
}




function  WHLX_Initializer_InitialCategory ( $ini )
{
	$dom_root            =  WHLX_DomXML_NewDocument  ( WHLX_XML_VERSION );    
	$txt_pi_xslt         =  WHLX_DomXML_RegisterXSLT ( $dom_root, $ini[ 'xslt' ][ 'cat_0001'     ], WHLX_XML_VERSION, 'text/xsl', 'UTF-8' );
	$dom_whlx            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_root      , 'whlx'         , '' );    
	$dom_category        =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_whlx      , 'category  '   , '' );    
//	$dom_mark            =  WHLX_DomXML_CreateComment( $dom_root, $dom_category  , ' mark '            );    
	$dom_item            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_category  , 'item'         , '' );    

	$dom_whlx ->set_attribute( 'series'  , '0001'                                );    
//	$dom_whlx ->set_attribute( 'category', '0001'                                );    
	$dom_whlx ->set_attribute( 'title'   , $ini[ 'title' ][ 'cat_0001'   ]       );    
	$dom_item ->set_attribute( 'id'      , '0001'                                );    
	$dom_item ->set_attribute( 'resource', $ini[ 'initial_article'  ][ 'url'   ] );    
	$dom_item ->set_attribute( 'title'   , $ini[ 'title' ][ 'art_0001'   ]       );    

	return WHLX_DomXML_Output( $dom_root, $ini[ 'directory' ][ 'data' ].  $ini[ 'filename' ][ 'cat_0001'     ], WHLX_XML_FILEMODE );    
}




function  WHLX_Initializer_InitialArticle  ( $ini )
{
	$dom_root            =  WHLX_DomXML_NewDocument  ( WHLX_XML_VERSION );    
	$txt_pi_xslt         =  WHLX_DomXML_RegisterXSLT ( $dom_root, $ini[ 'xslt' ][ 'art_0001'     ], WHLX_XML_VERSION, 'text/xsl', 'UTF-8' );
	$dom_whlx            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_root      , 'whlx'        , ''                                        );    
	$dom_items           =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_whlx      , 'items'       , ''                                        );    
	$dom_item1           =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_items     , 'item'        , ''                                        );    
//	$dom_mark            =  WHLX_DomXML_CreateComment( $dom_root, $dom_items     , ' mark '                                                  );    
	$dom_item1_title     =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_item1     , 'title    '   , $ini[ 'initial_article'  ][ 'title'     ] );    
	$dom_item1_url       =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_item1     , 'url      '   , $ini[ 'initial_article'  ][ 'url'       ] );    
	$dom_item1_text      =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_item1     , 'text     '   , $ini[ 'initial_article'  ][ 'text'      ] );    
	$dom_item1_creator   =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_item1     , 'creator  '   , $ini[ 'initial_article'  ][ 'creator'   ] );    
	$dom_item1_date      =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_item1     , 'date     '   , WHLX_DateTimeString()                     );    
	$dom_item1_trackback =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_item1     , 'trackback'   , $ini[ 'initial_article'  ][ 'trackback' ] );    

	$dom_whlx ->set_attribute( 'series'  , '0001'                                );    
	$dom_whlx ->set_attribute( 'category', '0001'                                );    
	$dom_whlx ->set_attribute( 'title'   , $ini[ 'title' ][ 'art_0001'   ]       );    
	$dom_item1->set_attribute( 'id'      , '0001'                                );    

	return WHLX_DomXML_Output( $dom_root, $ini[ 'directory' ][ 'data' ].  $ini[ 'filename' ][ 'art_0001'     ], WHLX_XML_FILEMODE );    
}




function  WHLX_Initializer_ListInformations( $ini )
{
	$dom_root            =  WHLX_DomXML_NewDocument  ( WHLX_XML_VERSION );    
	$txt_pi_xslt         =  WHLX_DomXML_RegisterXSLT ( $dom_root, $ini[ 'xslt' ][ 'informations' ], WHLX_XML_VERSION, 'text/xsl', 'UTF-8' );
	$dom_whlx            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_root, 'whlx'        , '' );    $dom_whlx           ->set_attribute( 'series', '0001' );    $dom_whlx           ->set_attribute( 'title', 'サイトの情報 etc.' );    
	$dom_info            =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_whlx, 'informations', '' );    
	$dom_infotitle       =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_infotitle      ->set_attribute( 'id',     '0001' );    $dom_infotitle      ->set_attribute( 'title', 'title'             );    $dom_infotitle      ->set_attribute( 'value', $ini[ 'informations'  ][ 'title'       ]  );    
	$dom_infolink        =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_infolink       ->set_attribute( 'id',     '0002' );    $dom_infolink       ->set_attribute( 'title', 'link'              );    $dom_infolink       ->set_attribute( 'value', $ini[ 'informations'  ][ 'link'        ]  );    
	$dom_infodescription =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_infodescription->set_attribute( 'id',     '0003' );    $dom_infodescription->set_attribute( 'title', 'description'       );    $dom_infodescription->set_attribute( 'value', $ini[ 'informations'  ][ 'description' ]  );    
	$dom_infodate        =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_infodate       ->set_attribute( 'id',     '0004' );    $dom_infodate       ->set_attribute( 'title', 'date'              );    $dom_infodate       ->set_attribute( 'value', WHLX_DateTimeString()                     );    
	$dom_infocreator     =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_infocreator    ->set_attribute( 'id',     '0005' );    $dom_infocreator    ->set_attribute( 'title', 'creator'           );    $dom_infocreator    ->set_attribute( 'value', $ini[ 'informations'  ][ 'creator'     ]  );    
	$dom_infopublisher   =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_infopublisher  ->set_attribute( 'id',     '0006' );    $dom_infopublisher  ->set_attribute( 'title', 'publisher'         );    $dom_infopublisher  ->set_attribute( 'value', $ini[ 'informations'  ][ 'publisher'   ]  );    
	$dom_inforights      =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_inforights     ->set_attribute( 'id',     '0007' );    $dom_inforights     ->set_attribute( 'title', 'rights'            );    $dom_inforights     ->set_attribute( 'value', $ini[ 'informations'  ][ 'rights'      ]  );    
	$dom_infolanguage    =  WHLX_DomXML_CreateChild  ( $dom_root, $dom_info, 'item'        , '' );    $dom_infolanguage   ->set_attribute( 'id',     '0008' );    $dom_infolanguage   ->set_attribute( 'title', 'language'          );    $dom_infolanguage   ->set_attribute( 'value', $ini[ 'informations'  ][ 'language'    ]  );    

	return WHLX_DomXML_Output( $dom_root, $ini[ 'directory' ][ 'data' ].  $ini[ 'filename' ][ 'informations' ], WHLX_XML_FILEMODE );    
}




function  WHLX_Initializer_ListOthers      ( $ini )
{
	$contents =  
		'	<contents> '                                                         .  "\r\n".    
		'		<item title="Index"        resource="./index.xml"        /> '.  "\r\n".    
		'		<item title="Recents"      resource="./recents.xml"      /> '.  "\r\n".    
		'		<item title="Excerpts"     resource="./excerpts.xml"     /> '.  "\r\n".    
		'		<item title="Contents"     resource="./contents.xml"     /> '.  "\r\n".    
		'		<item title="Informations" resource="./informations.xml" /> '.  "\r\n".    
		'		<item title="Categories"   resource="./categories.xml"   /> '.  "\r\n".    
		'		<item title="Articles"     resource="./articles.xml"     /> '.  "\r\n".    
		'		<item title="Comments"     resource="./comments.xml"     /> '.  "\r\n".    
		'		<item title="Trackbacks"   resource="./trackbacks.xml"   /> '.  "\r\n".    
	//	'		<item title="HTML"         resource="./html.xml"         /> '.  "\r\n".    
		'		<item title="初期化"       resource="./init.php"         /> '.  "\r\n".    
	//	'		<item title="新規投稿"     resource="./new.php"          /> '.  "\r\n".    
	//	'		<item title="返事"         resource="./tb.php"           /> '.  "\r\n".    
	//	'		<item title="編集"         resource="./edit.php"         /> '.  "\r\n".    
		'	</contents> '                                                        .  "\r\n";    

	$htmlhead =  
		'	<html> '                                                                                          .  "\r\n".    
		'		<base href="http://whlx.sourceforge.jp/whlx/" /> '                                        .  "\r\n".    
		'		<meta http-equiv="Content-Type"        content="application/xhtml+xml; charset=UTF-8" /> '.  "\r\n".    
		'		<meta http-equiv="Content-Language"    content="ja"                                   /> '.  "\r\n".    
		'		<meta http-equiv="Content-Script-Type" content="text/javascript;       charset=UTF-8" /> '.  "\r\n".    
		'		<meta http-equiv="Content-Style-Type"  content="text/css;              charset=UTF-8" /> '.  "\r\n".    
		'		<link rel="stylesheet" type="text/css"              href="./_default.css"     /> '        .  "\r\n".    
		'		<link rel="index"      type="application/xhtml+xml" href="./index.xml"        /> '        .  "\r\n".    
		'		<link rel="contents"   type="application/xhtml+xml" href="./contents.xml"     /> '        .  "\r\n".    
		'		<link rel="appendix"   type="application/xhtml+xml" href="./informations.xml" /> '        .  "\r\n".    
		'		<link rel="copyright"  type="application/xhtml+xml" href="./informations.xml" /> '        .  "\r\n".    
		'	</html> '                                                                                         .  "\r\n";    

	$filedata_index    =  '<?xml version="1.0" encoding="UTF-8" ?> '.  "\r\n".  '<?xml-stylesheet version="1.0" encoding="UTF-8" type="text/xsl" href="./_default.xsl" ?> '.  "\r\n".  '<whlx title="Index">          '.  "\r\n".  '<index />    '.  '</whlx> ';
	$filedata_recents  =  '<?xml version="1.0" encoding="UTF-8" ?> '.  "\r\n".  '<?xml-stylesheet version="1.0" encoding="UTF-8" type="text/xsl" href="./_default.xsl" ?> '.  "\r\n".  '<whlx title="Recent Entries"> '.  "\r\n".  '<recents />  '.  '</whlx> ';
	$filedata_excerpts =  '<?xml version="1.0" encoding="UTF-8" ?> '.  "\r\n".  '<?xml-stylesheet version="1.0" encoding="UTF-8" type="text/xsl" href="./_default.xsl" ?> '.  "\r\n".  '<whlx title="Excerptions">    '.  "\r\n".  '<excerpts /> '.  '</whlx> ';
	$filedata_contents =  '<?xml version="1.0" encoding="UTF-8" ?> '.  "\r\n".  '<?xml-stylesheet version="1.0" encoding="UTF-8" type="text/xsl" href="./_default.xsl" ?> '.  "\r\n".  '<whlx title="Contents">       '.  "\r\n".  $contents      .  '</whlx> ';
	$filedata_html     =  '<?xml version="1.0" encoding="UTF-8" ?> '.  "\r\n".  '<?xml-stylesheet version="1.0" encoding="UTF-8" type="text/xsl" href="./_default.xsl" ?> '.  "\r\n".  '<whlx title="HTML Headers">   '.  "\r\n".  $htmlhead      .  '</whlx> ';
	WHLX_FileOutput( $filedata_index   , $ini[ 'directory' ][ 'data' ].  './index.xml'   , 0744 );
	WHLX_FileOutput( $filedata_recents , $ini[ 'directory' ][ 'data' ].  './recents.xml' , 0744 );
	WHLX_FileOutput( $filedata_excerpts, $ini[ 'directory' ][ 'data' ].  './excerpts.xml', 0744 );
	WHLX_FileOutput( $filedata_contents, $ini[ 'directory' ][ 'data' ].  './contents.xml', 0744 );
	WHLX_FileOutput( $filedata_html    , $ini[ 'directory' ][ 'data' ].  './html.xml'    , 0744 );
}




?>
